/* CHK=0xD40E */
char *rev = "3.15";
/*+-------------------------------------------------------------------------
	config.c - Makefile configuration program for ECU
	wht@n4hgf.Mt-Park.GA.US

This must be compiled with the *NATIVE* cc or else you must fake all
of the predefines the native compiler supplies.  The Configure
script can pass stuff in CFLAGS to tickle config a bit.

There are a few tricks in here for SCO multi-target development
system.  If you compile this on a UNIX system, but specify the
target for a XENIX system, you get the cc -xenix switch.  You
also get -Dconst= to avoid banging into some problems with the
XENIX stuff in the header files.

To paraphrase Henry Spencer:
"Those who do not understand imake are doomed to reinvent it - poorly."
If this gets much more complicated, I'll make some imake rules.
Very soon, most of the systems ECU gets used on will have imake already.
We cannot assume that yet.

  Defined functions:
	gen_cc_cflags()
	gen_gcc_cflags()
	gen_isc_ldflags()
	gen_sco_ldflags()
	gen_sun_ldflags()
	gen_svr4_ldflags()
	generate_config(mdir)
	goodbye(sig)
	main(argc,argv)
	tgetc()
	tgetopt(prompt,choices)
	tgets(buf)
	tputstrs(strs)
	tputstrsfp(strs)

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:09-03-1991-12:53-wht@n4hgf2-iron out sun gcc options */
/*:09-01-1991-16:32-wht@n4hgf2-show package and config versions */
/*:09-01-1991-15:59-wht@n4hgf2-generalize HDB Devices, etc. files location */
/*:08-28-1991-14:07-wht@n4hgf2-SVR4 cleanup by aega84!lh */
/*:08-25-1991-14:39-wht@n4hgf-SVR4 port thanks to aega84!lh */
/*:08-23-1991-01:37-wht@n4hgf-sun port */
/*:07-25-1991-12:55-wht@n4hgf-ECU release 3.10 */
/*:07-12-1991-14:02-wht@n4hgf-GCC140 update */
/*:05-02-1991-02:46-wht@n4hgf-take out M_TERMCAP in favor of ecucurses.h */
/*:04-28-1991-03:44-wht@n4hgf-add -Dconst= for X286 under UNIX */
/*:04-20-1991-17:26-wht@n4hgf-creation */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <termio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "patchlevel.h"

#define S_SCO		0
#define S_ISC		1
#define S_SUN		2
#define S_SVR4		3

#define X_X286		0
#define X_X386		1
#define X_UNIX		2

#define C_CC		0
#define C_GCC		1

struct termio tty0;
struct termio tty1;
#define setty(arg) ioctl(0,TCSETAW,(arg) ? (char *)&tty1 : (char *)&tty0)

char *makedirs[] = {
	".",
	"./ecufriend",
	"./ecuungetty",
	"./gendial",
	"./help",
	"./sea",
	"./z",
	(char *)0
};

char *strs_intro1[] = {
	"\n",
	".-------------------.\n",
	"| ECU configuration |\n",
	"`-------------------'\n",
	(char *)0
};
char *strs_intro2[] = {
#ifdef WHT
	"WHT features enabled\n",
#endif
	"\n",
	"There are two types of responses, single character and string\n",
	"Single character questions have the choices in () followed by a ?\n",
	"String questions (with any defaults in []) are followed by a :\n",
	"If you wish to use the default for a string question, just press CR\n",
	"\n",
	"Abort (DEL, ^C, etc.) now if you do not wish to continue\n",
	(char *)0
};

char *strs_mkdep[] = {
	"\n",
	"You are ready to make the program. It make take a while (now is a good\n",
	"time to Read The Fine Manual).\n",
	"\n",
	"You MAY wish to make depend first.  It is not necessary to do this\n",
	"until you make source modifications or apply patches.\n",
	(char *)0
};
	

char *sco_cc_opts[] = {
	"\t-M2let128 -LARGE\\\n",			/* XENIX/286 */
	"\t-M3e\\\n",						/* XENIX/386 */
	"\t-M3e\\\n"						/* UNIX/386 */
};

char *sco_cc_optim[] = {
	"\t-Ot\\\n",						/* XENIX/286 */
	"\t-Octl -CSON\\\n",				/* XENIX/386 */
	"\t-Octl -CSON\\\n"					/* UNIX/386 */
};

char *sco_sigtype[] = {
	"\t-DSIGTYPE=int\\\n",				/* XENIX/286 */
	"\t-DSIGTYPE=void\\\n",				/* XENIX/386 */
	"\t-DSIGTYPE=void\\\n"				/* UNIX/386 */
};

/*
 * GCC CFLAGS
 */
char *gcc_opts[] = {
#ifdef PEDANTIC
	"\t-pedantic -ansi -O\\\n",		/* UH OH: see ecu README */
#else
	"\t-traditional -O\\\n",
#endif
#ifdef WHT
	"\t-v\\\n",
#endif
	"\t-fstrength-reduce -fpcc-struct-return -fwritable-strings\\\n",
	"\t-finline-functions -fforce-mem -fforce-addr\\\n",
	"\t-W -Wunused -Wpointer-arith -Wcast-qual\\\n",
	(char *)0
};

char *i86_gcc_opts[] = {
	"\t-fcall-used-bx\\\n",
	(char *)0
};

char *sco_gcc_opts[] = {
	"\t........what-goes-here?.........\\\n",				/* XENIX/286 */
	"\t-DM_XENIX -DM_SYSV -DM_SYS5 -DM_I386\\\n",			/* XENIX/386 */
	/* UNIX/386 */
	"\t-DM_BITFIELDS -DM_COFF -DM_I386 -DM_I86 -DM_I86SM\\\n\
\t-DM_INTERNAT -DM_SDATA -DM_STEXT -DM_SYS3 -DM_SYS5\\\n\
\t-DM_SYSIII -DM_SYSV -DM_UNIX -DM_WORDSWAP -DM_XENIX -Dunix\\\n",
};
char *isc_cc_opts  = "\t-O -DISC -DISC22 -DSYSV\\\n";
char *isc_gcc_opts = "\t-DISC -DISC22 -DSYSV\\\n";
char *isc_sigtype = "\t-DSIGTYPE=void\\\n";

char *sun_cc_opts  = "\t-O -DBSD\\\n";
char *sun_gcc_opts  = "\t-pipe -O -Dsun -DBSD\\\n"; /* ansi gets __sun__ only */
char *sun_sigtype = "\t-DSIGTYPE=void\\\n";

char *svr4_cc_opts  = "\t-O -DSVR4 -DSYSV\\\n";
char *svr4_gcc_opts = "\t-DSVR4 -DSYSV\\\n";
char *svr4_sigtype = "\t-DSIGTYPE=void\\\n";

/*
 * LIBS
 */
char *sco_libs[] = {
	"-ltcap -ltermlib -lx",
	"-ltcap -ltermlib -lx",
	"-ltcap -ltermlib -lx -lmalloc"
};

char *isc_libs = "-lcurses -linet -lx -lmalloc";

char *sun_libs = "-lcurses -ltermcap";

char *svr4_libs = "-lcurses -lx -lmalloc";

char *sco_system[] = {
	"XENIX/286",
	"XENIX/386",
	"UNIX/386"
};

char *isc_system = "ISC-2.2";

char *sun_system = "SunOS-4.1";

char *svr4_system = "SVR4.0";

char *malloc_3x = "\t-DMALLOC_3X\\\n";

char *bindir = "/usr/local/bin";
char *libdir = "/usr/local/lib/ecu";
char *symbolic = "";
char *use_ecuungetty = "yes";

int sys = -1;
int compiler = -1;
int have_gcc_140 = 0;
int sco_type = -1;
int debug = 0;

FILE *fpmake;

void
goodbye(sig)
int sig;
{
	setty(0);
	printf("\n");
	exit(sig);
}

void
tputstrs(strs)
char **strs;
{
	while(*strs)
		fputs(*strs++,stdout);
}

void
tputstrsfp(strs)
char **strs;
{
	while(*strs)
		fputs(*strs++,fpmake);
}

char
tgetc()
{
char rtn;

	setty(1);
	read(0,&rtn,1);
	rtn &= 0x7F;
	setty(0);
	printf("\n",rtn);
	return(rtn);
}

void
tgets(buf)
char *buf;
{
	if(!gets(buf))
		goodbye(1);
}

char
tgetopt(prompt,choices)
char *prompt;
char *choices;
{
char rtn = 0;
char response;
char *cptr;

	printf("\n%s (",prompt);
	while(!rtn)
	{
		cptr = choices;
		while(*cptr)
		{
			if(cptr - choices)
				putchar(',');
			putchar(*cptr++);
		}
		printf(")? ");
		if(strchr(choices,response = tgetc()))
			rtn = response;
		else
			printf("Please answer with one of ");
	}
	return(rtn);
}

void
gen_cc_cflags()
{

	fputs("CFLAGS = \\\n",fpmake);
	switch(sys)
	{
		case S_SCO:
#ifdef M_UNIX
			fputs("\t-nointl\\\n",fpmake);
			if(sco_type != X_UNIX)
				fputs("\t-xenix -Dconst=\\\n",fpmake);
#endif
			fputs("\t-DLINT_ARGS\\\n",fpmake);
			fputs(sco_cc_optim[sco_type],fpmake);
			fputs(sco_cc_opts[sco_type],fpmake);
			if(sco_type == X_UNIX)
				fputs(malloc_3x,fpmake);
			fputs(sco_sigtype[sco_type],fpmake);
			break;
		case S_ISC:
			fputs(isc_cc_opts,fpmake);
			fputs(malloc_3x,fpmake);
			fputs("\t-DWORKING_SELECT\\\n",fpmake);
			fputs(isc_sigtype,fpmake);
			break;
		case S_SUN:
			fputs(sun_cc_opts,fpmake);
			fputs(malloc_3x,fpmake);
			fputs("\t-DWORKING_SELECT\\\n",fpmake);
			fputs(isc_sigtype,fpmake);
			break;
		case S_SVR4:
			fputs(svr4_cc_opts,fpmake);
			fputs(malloc_3x,fpmake);
			fputs("\t-DWORKING_SELECT\\\n",fpmake);
			fputs(svr4_sigtype,fpmake);
			break;
	}
	fputs("\t-DECULIBDIR='\"$(ECULIBDIR)\"'\\\n",fpmake);
	fputs("\t-DHDBFILES='\"$(HDBFILES)\"'\\\n",fpmake);
	fputs("\t$(SYMBOLIC) $(CFLAGS_EXTRA) $(CC_CFLAGS_EXTRA)\n\n",fpmake);
}

void
gen_gcc_cflags()
{
	fputs("CFLAGS = \\\n",fpmake);
	tputstrsfp(gcc_opts);
	switch(sys)
	{
		case S_SCO:
			fputs(sco_gcc_opts[sco_type],fpmake);
			tputstrsfp(i86_gcc_opts);
			if(sco_type == X_UNIX)
				fputs(malloc_3x,fpmake);
			fputs(sco_sigtype[sco_type],fpmake);
			break;
		case S_ISC:
			fputs(isc_gcc_opts,fpmake);
			tputstrsfp(i86_gcc_opts);
			fputs(malloc_3x,fpmake);
			fputs("\t-DWORKING_SELECT\\\n",fpmake);
			fputs(isc_sigtype,fpmake);
			break;
		case S_SUN:
			fputs(sun_gcc_opts,fpmake);
			fputs(malloc_3x,fpmake);
			fputs("\t-DWORKING_SELECT\\\n",fpmake);
			fputs(sun_sigtype,fpmake);
			break;
		case S_SVR4:
			fputs(svr4_gcc_opts,fpmake);
#if defined(i386)
			tputstrsfp(i86_gcc_opts);
#endif
			fputs(malloc_3x,fpmake);
			fputs("\t-DWORKING_SELECT\\\n",fpmake);
			fputs(svr4_sigtype,fpmake);
			break;
	}
	fputs("\t-DECULIBDIR='\"$(ECULIBDIR)\"'\\\n",fpmake);
	fputs("\t-DHDBFILES='\"$(HDBFILES)\"'\\\n",fpmake);
	if(have_gcc_140)
		fputs("\t-DGCC140\\\n",fpmake);
	fputs("\t$(SYMBOLIC) $(CFLAGS_EXTRA) $(CC_CFLAGS_EXTRA)\n\n",fpmake);
}

void
gen_sco_ldflags()
{
	fputs("LDFLAGS = \\\n",fpmake);
#if defined(WHT)
	fputs("\t-g\\\n",fpmake);
#endif
	if(compiler == C_CC)
	{
#ifdef M_UNIX
		fputs("\t-nointl\\\n",fpmake);
		if(sco_type != X_UNIX)
			fputs("\t-xenix\\\n",fpmake);
#endif
		fputs(sco_cc_opts[sco_type],fpmake);
		if(sco_type == X_X286)
			fputs("\t-SEG 512 -F 5000\\\n",fpmake);
	}
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n",fpmake);

	fprintf(fpmake,"LIBS = %s\n\n",sco_libs[sco_type]);
}

void
gen_isc_ldflags()
{
	fputs("LDFLAGS = \\\n",fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n",fpmake);

	fprintf(fpmake,"LIBS = %s\n\n",isc_libs);
}

void
gen_sun_ldflags()
{
	fputs("LDFLAGS = \\\n",fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n",fpmake);

	fprintf(fpmake,"LIBS = %s\n\n",sun_libs);
}

void
gen_svr4_ldflags()
{
	fputs("LDFLAGS = \\\n",fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n",fpmake);

	fprintf(fpmake,"LIBS = %s\n\n",svr4_libs);
}

void
generate_config(mdir)
char *mdir;
{
char mksrc[128];
char mkfl[128];
char s128[128];
FILE *fpsrc;
FILE *local = fopen("config.local","r");;

	sprintf(mksrc,"%s/Make.src",mdir);
	sprintf(mkfl,"%s/Makefile",mdir);

	if(debug)
		printf("-----------%s------------\n",mksrc);
	else
		printf("Configuring %s from %s\n",mkfl,mksrc);

	if(!(fpsrc = fopen(mksrc,"r")))
	{
		perror(mksrc);
		return;
	}

	if(debug)
		fpmake = stdout;
	else
	{
		if(!(fpmake = fopen(mkfl,"w")))
		{
			perror(mksrc);
			fclose(fpsrc);
			return;
		}
	}

	fprintf(fpmake,"#---- Edit %s and rerun config to produce this file\n",
		mksrc);
	fprintf(fpmake,"#---- configured by ECU config rev %s\n\n",rev);

	if(local)
	{
		fprintf(fpmake,"# config.local inclusions\n");
		while(fgets(s128,sizeof(s128),local))
			fputs(s128,fpmake);
		fclose(local);
		fputs("\n",fpmake);
	}

	switch(compiler)
	{
		case C_CC:
			fputs("CC = cc\n\n",fpmake);
			gen_cc_cflags();
			break;
		case C_GCC:
			fputs("CC = gcc\n\n",fpmake);
			gen_gcc_cflags();
			break;
	}

	switch(sys)
	{
		case S_SCO:
			gen_sco_ldflags();
			break;
		case S_ISC:
			gen_isc_ldflags();
			break;
		case S_SUN:
			gen_sun_ldflags();
			break;
		case S_SVR4:
			gen_svr4_ldflags();
			break;
	}

	fprintf(fpmake,"LBIN = %s\n",bindir);
	fprintf(fpmake,"ECULIBDIR = %s\n",libdir);
	/*
	 * we need this info in Makefiles, so it is put here rather
	 * than ecu.h; must also have this passed thru in CFLAGS
	 */
	switch(sys)
	{
		case S_SCO:
			fprintf(fpmake,"SYSTEM = %s\n",sco_system[sco_type]);
			fprintf(fpmake,"HDBFILES = /usr/lib/uucp\n");
			use_ecuungetty = "yes";
			break;
		case S_ISC:
			fprintf(fpmake,"SYSTEM = %s\n",isc_system);
			fprintf(fpmake,"HDBFILES = /usr/lib/uucp\n");
			use_ecuungetty = "yes";
			break;
		case S_SUN:
			fprintf(fpmake,"SYSTEM = %s\n",sun_system);
			fprintf(fpmake,"HDBFILES = /etc/uucp\n");
			use_ecuungetty = "no";
			break;
		case S_SVR4:
			fprintf(fpmake,"SYSTEM = %s\n",svr4_system);
			fprintf(fpmake,"HDBFILES = /etc/uucp\n");
			use_ecuungetty = "no";
			break;
	}


	fprintf(fpmake,"USE_ECUUNGETTY = %s\n",use_ecuungetty);
#if !defined(WHT)
	fputs("#",fpmake);
#endif
	fputs("BINTIME = /bin/time\n",fpmake);

	fprintf(fpmake,"\n#---- end of configured make variables\n");

	while(!debug && fgets(s128,sizeof(s128),fpsrc))
		fputs(s128,fpmake);

	fclose(fpsrc);
	if(!debug)
		fclose(fpmake);

}

main(argc,argv)
int argc;
char **argv;
{
int itmp;
int getopt_libdir = 0;
int getopt_bindir = 0;
char s128[128];
char **makedir;
extern int optind;
extern char *optarg;

	setbuf(stdin,NULL);
	setbuf(stdout,NULL);

	while((itmp = getopt(argc,argv,"dsiS234ugcb:l:")) != -1)
	{
		switch(itmp)
		{
			case 'd': debug = 1; break;

			case 's': sys = S_SCO; break;
			case 'i': sys = S_ISC; break;
			case 'S': sys = S_SUN; break;
			case '4': sys = S_SVR4; break;

			case '2': sco_type = X_X286; break;
			case '3': sco_type = X_X386; break;
			case 'u': sco_type = X_UNIX; break;

			case 'g': compiler = C_GCC; break;
			case 'c': compiler = C_CC; break;

			case 'b':
				bindir = optarg;
				getopt_bindir = 1;
				break;

			case 'l':
				libdir = optarg;
				getopt_libdir = 1;
				break;
		}
	}

	/*
	 * set up raw/cooked tty setty() macro
	 */
	ioctl(0,TCGETA,&tty0);
	tty1 = tty0;
	tty1.c_lflag &= ~(ICANON);
	tty1.c_cc[VMIN] = 1;
	tty1.c_cc[VTIME] = 0;

	for(itmp = 1; itmp < 32; itmp++)
		signal(itmp,goodbye);

	if(!debug)
	{
		tputstrs(strs_intro1);
		printf("Package version 3.%d, config version %s\n",PATCHLEVEL,rev);
		tputstrs(strs_intro2);
	}

	if(sys < 0)
	{
		switch(tgetopt("Is this an SCO, ISC, SunOS 4.1, or SVR4 system",
			"siS4"))
		{
			case 's':  sys = S_SCO; break;
			case 'i':  sys = S_ISC; break;
			case 'S':  sys = S_SUN; break;
			case '4':  sys = S_SVR4; break;
		}
	}

	if((sys == S_SCO) && (sco_type < 0))
	{
		switch(tgetopt("XENIX/286, XENIX/386, or UNIX/386","23u"))
		{
			case '2':  sco_type = X_X286; break;
			case '3':  sco_type = X_X386; break;
			case 'u':  sco_type = X_UNIX; break;
		}
	}

	if((sys == S_SCO) && (sco_type == X_X286))
	{
		/* don't know about gcc on 286 systems */
		compiler = C_CC;
	}
	else
	{
		if(compiler < 0)
		{
			switch(tgetopt("Do you wish to use cc or gcc","cg"))
			{
				case 'c':  compiler = C_CC;  break;
				case 'g':
					compiler = C_GCC;
#ifdef PEDANTIC
					printf("I see we are being brave, er pedantic.\n");
#endif
					switch(tgetopt("Answer no if you are not sure.\n\
Do you have gcc 1.40 or later","yn"))
					{
						case 'y': have_gcc_140 = 1; break;
					}
					break;
			}
		}
	}

	if(!debug)
	{
		if(!getopt_bindir)
		{
			printf(
			"\nWhere do you want the public executables placed [%s]\n: ",
				bindir);
			tgets(s128);
			if(s128[0])
				bindir = strdup(s128);
		}

		if(!getopt_libdir)
		{
			printf(
			"\nWhere do you want the ECU library placed [%s]\n: ",libdir);
			tgets(s128);
			if(s128[0])
				libdir = strdup(s128);
		}
	}

	printf("\nThank you.\n\n");

	makedir = makedirs;
	while(*makedir)
		generate_config(*makedir++);

	if(!debug)
		tputstrs(strs_mkdep);

#ifdef WHT
	system("make depend");
#endif

	goodbye(0);
}

/* vi: set tabstop=4 shiftwidth=4: */
/* end of config.c */
